USE [msdb]
GO

/****** Object:  Job [CenterToTime]    Script Date: 10/08/2023 3:18:50 PM ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 10/08/2023 3:18:50 PM ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'CenterToTime', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'Insert traffic from dbDataCenter to PalizTime', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Insert]    Script Date: 10/08/2023 3:18:51 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Insert', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=3, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE [dbDataCenter]
GO
DECLARE @Temp TABLE
(
	[CardID] bigint,
	[Date1] datetime,
	[Date] int,
	[Time] int,
	[ReadCounter] tinyint,
	[InOutType] tinyint
);

INSERT INTO @Temp ([CardID], [Date],[Date1], [Time], [ReadCounter], [InOutType])
SELECT dbo.tblInOutData.[CardID],[Date], CAST( CAST((2000+ [Date]/10000) as NVARCHAR(4))+''-''+CAST(([Date] % 10000)/100 AS NVARCHAR(2))+''-''+CAST(([Date] % 100) AS NVARCHAR(2))+'' ''+
			CAST([Time]/10000 AS NVARCHAR(2))+'':''+CAST(([Time]%10000)/100 AS NVARCHAR(2))+'':0'' AS DATETIME), 
			dbo.tblInOutData.[Time], dbo.tblInOutData.[ReadCounter],dbo.tblInOutData.[InOutType] 
FROM            dbo.tblInOutData WHERE dbo.tblInOutData.ReadCounter=0;
DECLARE db_cursor CURSOR FOR SELECT DISTINCT [CardID], [Date],[Date1], [Time],[ReadCounter], [InOutType] FROM @Temp;
DECLARE @CardID bigint;
DECLARE	@Date1 datetime;
DECLARE	@Date int;
DECLARE	@Time int;
DECLARE @ReadCounter tinyint;
DECLARE @InOutType tinyint;

DECLARE @UserID int;
DECLARE @DeviceID int;
DECLARE @TrafficTypeID tinyint;

	SET @DeviceID=(SELECT TOP 1 DeviceID FROM PalizTime.dbo.Device);

OPEN db_cursor;

FETCH NEXT FROM db_cursor INTO @CardID,@Date,@Date1,@Time,@ReadCounter,@InOutType;

WHILE @@FETCH_STATUS=0
BEGIN
	BEGIN TRY

	IF @InOutType=226 
		SET @TrafficTypeID=2
	ELSE IF @InOutType=235
		SET @TrafficTypeID=3
	ELSE IF @InOutType=236
		SET @TrafficTypeID=4
	ELSE IF @InOutType=204
		SET @TrafficTypeID=5
	ELSE 
		SET @TrafficTypeID=1

	SET @UserID=(SELECT TOP 1 UserID FROM PalizTime.dbo.[User] where CAST(PersonelCode AS BIGINT)=@CardID);
		IF @UserID IS NOT NULL 
		BEGIN
			SET XACT_ABORT ON;
			BEGIN TRAN;
				INSERT INTO PalizTime.dbo.Traffic (UserID,Date,TrafficeTypeID,DeviceID,Deleted)
				VALUES (@UserID,@Date1,@TrafficTypeID,@DeviceID,0)
				UPDATE dbo.tblInOutData SET ReadCounter=1 WHERE [CardID]=@CardID AND [Date]=@Date AND [Time]=@Time
				UPDATE PalizTime.dbo.UserDailyInfo SET IsValid=0 WHERE [UserID]=@UserID AND [Date]=CONVERT(date,@Date1)
			COMMIT TRAN;
		END
	END TRY
	BEGIN CATCH
	ROLLBACK TRAN;
	END CATCH
	FETCH NEXT FROM db_cursor INTO @CardID,@Date,@Date1,@Time,@ReadCounter,@InOutType;
END;
CLOSE db_cursor;
DEALLOCATE db_cursor;

--SET XACT_ABORT ON;
--		BEGIN TRAN;
--		UPDATE dbo.tblInOutData SET ReadCounter=1 FROM dbo.tblInOutData INNER JOIN @Temp as T ON dbo.tblInOutData.CardID=T.CardID AND dbo.tblInOutData.[Date]=T.[Date] AND dbo.tblInOutData.[Time]=T.[Time];
--		INSERT INTO PalizTime.dbo.Traffic (UserID,Date,TrafficeTypeID,DeviceID,Deleted) SELECT PalizTime.dbo.[User].UserID,TT.[Date1],1,1,0 FROM @Temp AS TT INNER JOIN PalizTime.dbo.[User] ON CAST(PersonelCode AS BIGINT)=[CardID]
--		UPDATE PalizTime.dbo.UserDailyInfo SET IsValid=0 FROM PalizTime.dbo.[UserDailyInfo] AS UD INNER JOIN PalizTime.dbo.[User] AS U ON UD.[UserID]=U.[UserID] INNER JOIN @Temp AS TT ON CAST(PersonelCode AS BIGINT)=TT.CardID AND UD.[Date]=CAST(TT.Date1 AS Date)
--		COMMIT TRAN;', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [DeleteOld]    Script Date: 10/08/2023 3:18:51 PM ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'DeleteOld', 
		@step_id=2, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'DECLARE @d DATE;
DECLARE @dd INT;
SET @d=DATEADD(MONTH,-3,GETDATE());
SET @dd=(YEAR(@d)%100)*10000+MONTH(@d)*100+DAY(@d);

DELETE FROM dbDataCenter.dbo.tblInOutData WHERE Date<@dd', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Main', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=5, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20180807, 
		@active_end_date=99991231, 
		@active_start_time=1, 
		@active_end_time=235900, 
		@schedule_uid=N'4dc4ba98-1dfd-43ee-8cea-3e8fab1b6d09'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO


